static MergeBranch  _MergeBranch;

public class MergeBranch : Object
{
    public Gtk.Dialog el;
    private MergeBranch  _this;

    public static MergeBranch singleton()
    {
        if (_MergeBranch == null) {
            _MergeBranch= new MergeBranch();
        }
        return _MergeBranch;
    }
    public Xcls_table table;
    public Xcls_actionsel actionsel;
    public Xcls_actioncellrenderer actioncellrenderer;
    public Xcls_actionmodel actionmodel;
    public Xcls_projectsel projectsel;
    public Xcls_prcellrenderer prcellrenderer;
    public Xcls_prmodel prmodel;
    public Xcls_ticketsel ticketsel;
    public Xcls_dbcellrenderer dbcellrenderer;
    public Xcls_dbmodel dbmodel;
    public Xcls_btn_not_me btn_not_me;
    public Xcls_btn_closed btn_closed;
    public Xcls_name name;
    public Xcls_label_diff label_diff;
    public Xcls_label_ticket label_ticket;
    public Xcls_diff_view diff_view;
    public Xcls_scrolled_window scrolled_window;
    public Xcls_view view;
    public Xcls_spinner spinner;
    public Xcls_mergebtn mergebtn;

        // my vars (def)
    public GitRepo repo;
    public RooTicket? ticket;
    public bool running;

    // ctor
    public MergeBranch()
    {
        _this = this;
        this.el = new Gtk.Dialog();

        // my vars (dec)
        this.ticket = null;
        this.running = false;

        // set gobject values
        this.el.title = "Merge Branch";
        this.el.default_height = 200;
        this.el.default_width = 500;
        this.el.deletable = true;
        this.el.modal = true;
        var child_0 = new Xcls_Box2( _this );
        child_0.ref();
        this.el.get_content_area().add (  child_0.el  );
        var child_1 = new Xcls_Button32( _this );
        child_1.ref();
        this.el.add_action_widget (  child_1.el , 0 );
        var child_2 = new Xcls_mergebtn( _this );
        child_2.ref();
        this.el.add_action_widget (  child_2.el , 1 );

        //listeners
        this.el.delete_event.connect( (self, event) => {
            this.el.hide();
            return true; 
            //test  
        });
        this.el.response.connect( (self, response_id) =>  { 
          
        	GLib.debug("got %d", (int) response_id);
        	if (response_id < 1) {
        	    _this.el.hide();	
        	    this.running = false; 
            	GitMonitor.gitmonitor.start();
        	 	return;
        	}
        	
        	
        	
        	 /*
        	// have they selected a ticket..
        	// make that the current active ticket?
        	// we really need to store locally what ticket is being worked on..
        	// in theory we could be working on multiple project and not merging..
        	// -- each repo would have their active ticket (only one per repo)
        	// -- so we could just store that in there
        	// -- initial load can check the contents of the ticket files on first scan.
        	var ticket_id = _this.ticketsel.selectedTicketId();
        	
            if (this.repo != null) {
            	var bn = _this.name.el.get_text();
            	if (ticket_id != "" ) {
        			this.repo.setActiveTicket( RooTicket.singleton().getById(ticket_id), bn);
        		} else {
        			this.repo.createBranchNamed(bn);
        		}
            }
        	*/
        	
        	if (this.repo != null) {
        		repo.doMerge(
        			_this.actionsel.selectedAction(), 
        			_this.ticketsel.selectedTicketId(),
        			_this.name.el.get_text()
        		);
        	
        	} else {
        		GitRepo.doMerges(
        			_this.actionsel.selectedAction(), 
        			_this.ticketsel.selectedTicketId(),
        			_this.name.el.get_text()
        		);
        	}
        	this.running = false; 
        
        	 
        	_this.el.hide();	
         	GitMonitor.gitmonitor.start();
        
        	 
        });
    }

    // user defined functions
    public   void show (  RooTicket ticket, GitRepo? repo ) 
    {
         // this.el.set_gravity(Gdk.Gravity.NORTH);
        if (this.running) {
        	return;
    	}
    	GitMonitor.gitmonitor.stop();
    	
    	_this.el.show_all();
    	
    	_this.table.el.hide();
    	_this.scrolled_window.el.hide();
    	_this.spinner.el.show();
    	_this.spinner.el.start();	
    	this.el.set_keep_above(true);    
    	this.el.move((Gdk.Screen.width() / 2)- 250 ,0);
           	GLib.debug("Loading tickets"); 
     
    	
        this.ticket = ticket;
        this.repo = repo;
        
    	
    	Timeout.add_seconds(1, () => {
    	
            _this.prmodel.loadProjects(ticket.project_id);
    	
    	    _this.diff_view.el.get_buffer().set_text(
    	    	repo != null ? repo.previewMerge() : GitRepo.previewMerges(ticket.id)
        	);		
    		// if we are not working on a ticket, then we should be able to pick one?
    	 	_this.dbmodel.loadTickets(ticket.project_id);
    	 	_this.actionmodel.loadActions();
    	 	_this.mergebtn.updateState();
    		_this.view.loadTicket(ticket.id);
    		_this.spinner.el.stop();
    		_this.spinner.el.hide();	
    
    		this.table.el.show();
    		return false;
    	});
    	
    	this.el.run();
    	 
    }
    public class Xcls_Box2 : Object
    {
        public Gtk.Box el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Box2(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Box( Gtk.Orientation.VERTICAL, 0 );

            // my vars (dec)

            // set gobject values
            var child_0 = new Xcls_table( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , false,false,0 );
            var child_1 = new Xcls_Notebook22( _this );
            child_1.ref();
            this.el.add (  child_1.el  );
            var child_2 = new Xcls_spinner( _this );
            child_2.ref();
            this.el.add (  child_2.el  );
        }

        // user defined functions
    }
    public class Xcls_table : Object
    {
        public Gtk.Table el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_table(MergeBranch _owner )
        {
            _this = _owner;
            _this.table = this;
            this.el = new Gtk.Table( 4, 2, false );

            // my vars (dec)

            // set gobject values
            this.el.margin = 2;
            this.el.column_spacing = 2;
            this.el.vexpand = false;
            var child_0 = new Xcls_Label4( _this );
            child_0.ref();
            this.el.attach_defaults (  child_0.el , 0,1,0,1 );
            var child_1 = new Xcls_actionsel( _this );
            child_1.ref();
            this.el.attach_defaults (  child_1.el , 1,2,0,1 );
            var child_2 = new Xcls_Label8( _this );
            child_2.ref();
            this.el.attach_defaults (  child_2.el , 0,1,1,2 );
            var child_3 = new Xcls_projectsel( _this );
            child_3.ref();
            this.el.attach_defaults (  child_3.el , 1,2,1,2 );
            var child_4 = new Xcls_Label12( _this );
            child_4.ref();
            this.el.attach_defaults (  child_4.el , 0,1,2,3 );
            var child_5 = new Xcls_ticketsel( _this );
            child_5.ref();
            this.el.attach_defaults (  child_5.el , 1,2,2,3 );
            var child_6 = new Xcls_Box16( _this );
            child_6.ref();
            this.el.attach_defaults (  child_6.el , 0,2,3,4 );
            var child_7 = new Xcls_Label20( _this );
            child_7.ref();
            this.el.attach_defaults (  child_7.el , 0,1,4,5 );
            var child_8 = new Xcls_name( _this );
            child_8.ref();
            this.el.attach_defaults (  child_8.el , 1,2,4,5 );
        }

        // user defined functions
    }
    public class Xcls_Label4 : Object
    {
        public Gtk.Label el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label4(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "Do what?" );

            // my vars (dec)

            // set gobject values
            this.el.margin_right = 3;
            this.el.halign = Gtk.Align.END;
            this.el.visible = true;
        }

        // user defined functions
    }

    public class Xcls_actionsel : Object
    {
        public Gtk.ComboBox el;
        private MergeBranch  _this;


            // my vars (def)
        public bool loading;

        // ctor
        public Xcls_actionsel(MergeBranch _owner )
        {
            _this = _owner;
            _this.actionsel = this;
            this.el = new Gtk.ComboBox();

            // my vars (dec)
            this.loading = false;

            // set gobject values
            this.el.hexpand = true;
            var child_0 = new Xcls_actioncellrenderer( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , true );
            var child_1 = new Xcls_actionmodel( _this );
            child_1.ref();
            this.el.set_model (  child_1.el  );

            // init method

            this.el.add_attribute(_this.actioncellrenderer.el , "markup", 1 );

            //listeners
            this.el.changed.connect( () => {
            	if (this.loading) {
            		return;
            	}
              	_this.name.updateText();
              	_this.mergebtn.updateState();
            	//GLib.debug (//"Selection: %s, %s\n", (string) val1, (string) val2);
            });
        }

        // user defined functions
        public string selectedAction () {
        	Gtk.TreeIter iter;
        	Value val1;
         
        	this.el.get_active_iter (out iter);
        	_this.actionmodel.el.get_value (iter, 0, out val1);
        
        	return  (string) val1;
        }
    }
    public class Xcls_actioncellrenderer : Object
    {
        public Gtk.CellRendererText el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_actioncellrenderer(MergeBranch _owner )
        {
            _this = _owner;
            _this.actioncellrenderer = this;
            this.el = new Gtk.CellRendererText();

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_actionmodel : Object
    {
        public Gtk.ListStore el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_actionmodel(MergeBranch _owner )
        {
            _this = _owner;
            _this.actionmodel = this;
            this.el = new Gtk.ListStore( 2, typeof(string),typeof(string) );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
        public void loadActions () {
        
         
            
            _this.actionsel.loading = true;
        
            this.el.clear();                                    
            Gtk.TreeIter iter;
            var el = this.el;
            
            el.append(out iter);
        
            
            el.set_value(iter, 0, "");
            el.set_value(iter, 1, "-- select action  --");
            
            _this.actionsel.el.set_active_iter(iter);
        
            el.append(out iter);    
            el.set_value(iter, 0, "CLOSE");
            el.set_value(iter, 1, "Merge changes to master - and CLOSE ticket");
                
                
            el.append(out iter);    
            el.set_value(iter, 0, "LEAVE");
            el.set_value(iter, 1, "Merge changes to master - and LEAVE ticket open");
        
            el.append(out iter);    
            el.set_value(iter, 0, "MASTER");
            el.set_value(iter, 1, "Merge changes FROM master into this branch");    
            
            el.append(out iter);    
            el.set_value(iter, 0, "EXIT");
            el.set_value(iter, 1, "Switch back to MASTER branch - no merge");    
            
            
            
            _this.actionsel.loading = false;
             //this.el.set_sort_column_id(0, Gtk.SortType.ASCENDING);          
                                             
        }
    }


    public class Xcls_Label8 : Object
    {
        public Gtk.Label el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label8(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "Project" );

            // my vars (dec)

            // set gobject values
            this.el.margin_right = 3;
            this.el.halign = Gtk.Align.END;
            this.el.visible = true;
        }

        // user defined functions
    }

    public class Xcls_projectsel : Object
    {
        public Gtk.ComboBox el;
        private MergeBranch  _this;


            // my vars (def)
        public bool loading;

        // ctor
        public Xcls_projectsel(MergeBranch _owner )
        {
            _this = _owner;
            _this.projectsel = this;
            this.el = new Gtk.ComboBox.with_entry();

            // my vars (dec)
            this.loading = false;

            // set gobject values
            this.el.hexpand = true;
            var child_0 = new Xcls_prcellrenderer( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , true );
            var child_1 = new Xcls_prmodel( _this );
            child_1.ref();
            this.el.set_model (  child_1.el  );

            // init method

            this.el.set_entry_text_column(1);
            this.el.get_child().set_sensitive(false);

            //listeners
            this.el.changed.connect( () => {
            	if (this.loading) {
            		return;
            	}
            	var project_id = this.selectedProjectId();
            	_this.dbmodel.loadTickets(project_id);
            	
            	
            	/*if (this.loading) {
            		return;
            	}
            	var ticket_id = this.selectedTicketId();
            	
            	var name = RooTicket.singleton().usernameLocal();
            	
            	if (ticket_id == "" || ticket_id == null) {
            	
            		var dt = new  DateTime.now_local();
            		_this.name.el.set_text("wip_%s_%s".printf(name,dt.format("%Y_%b_%d")));
            		return;
            	}
            	
            	
            	var ticket = RooTicket.singleton().getById(ticket_id);
               
            	_this.name.el.set_text("wip_%s_T%s_%s".printf(name,ticket.id, ticket.summaryToBranchName()));
            	
            	//GLib.debug (//"Selection: %s, %s\n", (string) val1, (string) val2);
            	*/
            });
        }

        // user defined functions
        public string selectedProjectId () {
        	Gtk.TreeIter iter;
        	Value val1;
         
         
        	this.el.get_active_iter (out iter);
        	_this.prmodel.el.get_value (iter, 0, out val1);
         
        
        	return  (string) val1;
        	
        	
        	
        	
        }
    }
    public class Xcls_prcellrenderer : Object
    {
        public Gtk.CellRendererText el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_prcellrenderer(MergeBranch _owner )
        {
            _this = _owner;
            _this.prcellrenderer = this;
            this.el = new Gtk.CellRendererText();

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_prmodel : Object
    {
        public Gtk.ListStore el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_prmodel(MergeBranch _owner )
        {
            _this = _owner;
            _this.prmodel = this;
            this.el = new Gtk.ListStore( 2, typeof(string),typeof(string) );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
        public void loadProjects (string id) {
        
        
            
            _this.projectsel.loading = true;
        
            this.el.clear();                                    
            Gtk.TreeIter iter;
            var el = this.el;
            
            el.append(out iter);
        
            
            el.set_value(iter, 0, "");
            el.set_value(iter, 1, "-- select a project --");
            if (id == "") {
        	    _this.projectsel.el.set_active_iter(iter);
            }
          
            foreach(var project in RooProject.projects()) {
            
                el.append(out iter);
                
                el.set_value(iter, 0, project.id);
                el.set_value(iter, 1,  project.name );
                if (id == project.id) {
        	 	   _this.projectsel.el.set_active_iter(iter);
        	    }   
                
            }
            
            _this.projectsel.loading = false;
             //this.el.set_sort_column_id(0, Gtk.SortType.ASCENDING);          
                                             
        }
    }


    public class Xcls_Label12 : Object
    {
        public Gtk.Label el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label12(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "Select Ticket" );

            // my vars (dec)

            // set gobject values
            this.el.margin_right = 3;
            this.el.halign = Gtk.Align.END;
            this.el.justify = Gtk.Justification.RIGHT;
            this.el.xalign = 0.900000f;
            this.el.visible = true;
        }

        // user defined functions
    }

    public class Xcls_ticketsel : Object
    {
        public Gtk.ComboBox el;
        private MergeBranch  _this;


            // my vars (def)
        public bool loading;

        // ctor
        public Xcls_ticketsel(MergeBranch _owner )
        {
            _this = _owner;
            _this.ticketsel = this;
            this.el = new Gtk.ComboBox.with_entry();

            // my vars (dec)
            this.loading = false;

            // set gobject values
            var child_0 = new Xcls_dbcellrenderer( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , true );
            var child_1 = new Xcls_dbmodel( _this );
            child_1.ref();
            this.el.set_model (  child_1.el  );

            // init method

            //this.el.add_attribute(_this.dbcellrenderer.el , "markup", 1 );
            this.el.set_entry_text_column(1);
            this.el.get_child().set_sensitive(false);

            //listeners
            this.el.changed.connect( () => {
            	if (this.loading) {
            		return;
            	}
            	  
            	_this.view.loadTicket(this.selectedTicketId());
            	 _this.name.updateText();
            	//GLib.debug (//"Selection: %s, %s\n", (string) val1, (string) val2);
            });
        }

        // user defined functions
        public string selectedTicketId () {
        Gtk.TreeIter iter;
        	Value val1;
         
         
        	if (!this.el.get_active_iter (out iter)) {
        		return "";
        	}
        	 
        	_this.dbmodel.el.get_value (iter, 0, out val1);
         
        
        	return  (string) val1;
        	
        	
        	
        	
        }
    }
    public class Xcls_dbcellrenderer : Object
    {
        public Gtk.CellRendererText el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_dbcellrenderer(MergeBranch _owner )
        {
            _this = _owner;
            _this.dbcellrenderer = this;
            this.el = new Gtk.CellRendererText();

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_dbmodel : Object
    {
        public Gtk.ListStore el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_dbmodel(MergeBranch _owner )
        {
            _this = _owner;
            _this.dbmodel = this;
            this.el = new Gtk.ListStore( 2, typeof(string),typeof(string) );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
        public void loadTickets (string project_id  ) {
        
        
            
            // fixme .. get project id from selection..
            
             RooTicket.singleton().loadTickets(
         			project_id,
         			_this.btn_not_me.el.active ? RooTicket.Who.ANYBODY :  RooTicket.Who.ME,
         			 _this.btn_closed.el.active ? RooTicket.Status.ALL :  RooTicket.Status.ACTIVE
        		 );
                
            _this.ticketsel.loading = true;
        
            this.el.clear();                                    
            Gtk.TreeIter iter;
            var el = this.el;
            
            el.append(out iter);
        
            
            el.set_value(iter, 0, "");
            el.set_value(iter, 1, "-- select a ticket --");
            
            _this.ticketsel.el.set_active_iter(iter);
            
            if (_this.ticket != null &&  _this.ticket.id == "-1") {
        		el.append(out iter);
        		el.set_value(iter, 0, "-1");
        		el.set_value(iter, 1, "Temporary Branch - No ticket specified/relivant");
                _this.ticketsel.el.set_active_iter(iter);	
             }
            
            
            
            var tickets = RooTicket.singleton().tickets;
            foreach(var ticket in tickets) {
            
                el.append(out iter);
                
                el.set_value(iter, 0, ticket.id);
                el.set_value(iter, 1, "#%s [%s] %s".printf( ticket.id, ticket.project_id_name , ticket.summary));
                
                if (_this.ticket != null && _this.ticket.id == ticket.id) {
        		    _this.ticketsel.el.set_active_iter(iter);
                }
                
            }
            
            _this.ticketsel.loading = false;
             //this.el.set_sort_column_id(0, Gtk.SortType.ASCENDING);          
                                             
        }
    }


    public class Xcls_Box16 : Object
    {
        public Gtk.Box el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Box16(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Box( Gtk.Orientation.HORIZONTAL, 0 );

            // my vars (dec)

            // set gobject values
            var child_0 = new Xcls_btn_not_me( _this );
            child_0.ref();
            this.el.add (  child_0.el  );
            var child_1 = new Xcls_btn_closed( _this );
            child_1.ref();
            this.el.add (  child_1.el  );
            var child_2 = new Xcls_Label19( _this );
            child_2.ref();
            this.el.add (  child_2.el  );
        }

        // user defined functions
    }
    public class Xcls_btn_not_me : Object
    {
        public Gtk.CheckButton el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_btn_not_me(MergeBranch _owner )
        {
            _this = _owner;
            _this.btn_not_me = this;
            this.el = new Gtk.CheckButton();

            // my vars (dec)

            // set gobject values
            this.el.label = "Show tickets not assigned to me";

            //listeners
            this.el.toggled.connect( () => {
            	var project_id = _this.projectsel.selectedProjectId();
            	_this.dbmodel.loadTickets(project_id);	
            });
        }

        // user defined functions
    }

    public class Xcls_btn_closed : Object
    {
        public Gtk.CheckButton el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_btn_closed(MergeBranch _owner )
        {
            _this = _owner;
            _this.btn_closed = this;
            this.el = new Gtk.CheckButton();

            // my vars (dec)

            // set gobject values
            this.el.label = "Show closed Tickets";

            //listeners
            this.el.toggled.connect( () => {
             	var project_id = _this.projectsel.selectedProjectId();
            	_this.dbmodel.loadTickets(project_id);	
            	 
            });
        }

        // user defined functions
    }

    public class Xcls_Label19 : Object
    {
        public Gtk.Label el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label19(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "<a href=\"refresh\">Refresh Ticket list</a>" );

            // my vars (dec)

            // set gobject values
            this.el.halign = Gtk.Align.END;
            this.el.hexpand = true;
            this.el.use_markup = true;

            //listeners
            this.el.activate_link.connect( (uri) => {
            	if (uri == "refresh") {
            		RooProject.reload();
            		var curproj = RooProject.getProjectByRepo(_this.repo);
            		 _this.prmodel.loadProjects(curproj == null ? "": curproj.id);
            
            		_this.dbmodel.loadTickets(curproj == null ? "": curproj.id);		
            	}
            	return true;
            });
        }

        // user defined functions
    }


    public class Xcls_Label20 : Object
    {
        public Gtk.Label el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Label20(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Label( "Use this commit message" );

            // my vars (dec)

            // set gobject values
            this.el.margin_right = 3;
            this.el.halign = Gtk.Align.END;
        }

        // user defined functions
    }

    public class Xcls_name : Object
    {
        public Gtk.Entry el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_name(MergeBranch _owner )
        {
            _this = _owner;
            _this.name = this;
            this.el = new Gtk.Entry();

            // my vars (dec)

            // set gobject values
            this.el.visible = true;
        }

        // user defined functions
        public void updateText () {
        	var ticket_id = _this.ticketsel.selectedTicketId();
        	 
        	RooTicket ticket = null;
        	if (ticket_id.length > 0){
        		ticket = RooTicket.singleton().getById(ticket_id);
        	}
        	
        	var name = RooTicket.singleton().usernameLocal();
        	var action = _this.actionsel.selectedAction();
        	this.el.set_editable(true); 
         	switch (action) {
         		case "CLOSE": // merge changes and close..
        	 		this.el.set_text("Fix #%s - %s".printf(ticket_id, ticket != null ? ticket.summary : ""));
        	 		break;
        	 	case "LEAVE": // partial fix	
        	 		this.el.set_text("Partial Fix #%s - %s".printf(ticket_id,   ticket != null ? ticket.summary : ""));
        	 		break;
         		case "MASTER": // merge master
         		case "EXIT": // just switch back... 		
         			this.el.set_editable(false);
        	 		this.el.set_text(""); // not relivant.. 			
        			break;
         		default:
         		
         			break; /// don't fix the text value.
        	}
           
        }
    }


    public class Xcls_Notebook22 : Object
    {
        public Gtk.Notebook el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Notebook22(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Notebook();

            // my vars (dec)

            // set gobject values
            this.el.vexpand = true;
            var child_0 = new Xcls_label_diff( _this );
            child_0.ref();
            var child_1 = new Xcls_label_ticket( _this );
            child_1.ref();
            var child_2 = new Xcls_Box25( _this );
            child_2.ref();
            this.el.append_page (  child_2.el , _this.label_diff.el );
            var child_3 = new Xcls_Box28( _this );
            child_3.ref();
            this.el.append_page (  child_3.el , _this.label_ticket.el );
        }

        // user defined functions
    }
    public class Xcls_label_diff : Object
    {
        public Gtk.Label el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_label_diff(MergeBranch _owner )
        {
            _this = _owner;
            _this.label_diff = this;
            this.el = new Gtk.Label( "Projected Commit Diff" );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_label_ticket : Object
    {
        public Gtk.Label el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_label_ticket(MergeBranch _owner )
        {
            _this = _owner;
            _this.label_ticket = this;
            this.el = new Gtk.Label( "Ticket Details" );

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
    }

    public class Xcls_Box25 : Object
    {
        public Gtk.Box el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Box25(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Box( Gtk.Orientation.VERTICAL, 0 );

            // my vars (dec)

            // set gobject values
            this.el.homogeneous = false;
            var child_0 = new Xcls_ScrolledWindow26( _this );
            child_0.ref();
            this.el.pack_start (  child_0.el , true,true,0 );
        }

        // user defined functions
    }
    public class Xcls_ScrolledWindow26 : Object
    {
        public Gtk.ScrolledWindow el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_ScrolledWindow26(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.ScrolledWindow( null, null );

            // my vars (dec)

            // set gobject values
            this.el.height_request = 400;
            var child_0 = new Xcls_diff_view( _this );
            child_0.ref();
            this.el.add (  child_0.el  );
        }

        // user defined functions
    }
    public class Xcls_diff_view : Object
    {
        public Gtk.SourceView el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_diff_view(MergeBranch _owner )
        {
            _this = _owner;
            _this.diff_view = this;
            this.el = new Gtk.SourceView();

            // my vars (dec)

            // init method

            var description =   Pango.FontDescription.from_string("monospace");
                description.set_size(9000);
                this.el.override_font(description);
                 var lm = Gtk.SourceLanguageManager.get_default();
                                
                ((Gtk.SourceBuffer)(this.el.get_buffer())).set_language(
                    lm.get_language("diff")
                );
        }

        // user defined functions
    }



    public class Xcls_Box28 : Object
    {
        public Gtk.Box el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Box28(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Box( Gtk.Orientation.VERTICAL, 0 );

            // my vars (dec)

            // set gobject values
            this.el.homogeneous = false;
            var child_0 = new Xcls_scrolled_window( _this );
            child_0.ref();
            this.el.add (  child_0.el  );
        }

        // user defined functions
    }
    public class Xcls_scrolled_window : Object
    {
        public Gtk.ScrolledWindow el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_scrolled_window(MergeBranch _owner )
        {
            _this = _owner;
            _this.scrolled_window = this;
            this.el = new Gtk.ScrolledWindow( null, null );

            // my vars (dec)

            // set gobject values
            this.el.height_request = 500;
            this.el.vexpand = true;
            var child_0 = new Xcls_view( _this );
            child_0.ref();
            this.el.add (  child_0.el  );

            // init method

            {
            	this.el.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC);
            }
        }

        // user defined functions
    }
    public class Xcls_view : Object
    {
        public WebKit.WebView el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_view(MergeBranch _owner )
        {
            _this = _owner;
            _this.view = this;
            this.el = new WebKit.WebView();

            // my vars (dec)

            // set gobject values
        }

        // user defined functions
        public void loadTicket (string tid) {
        	int h,w;
        	_this.el.get_size(out w, out h);
        	
        	if (tid == "") {
        		_this.scrolled_window.el.hide();
        		_this.el.resize(w, 150);
        	} else {
        		_this.scrolled_window.el.show();
        		_this.el.resize(w, 800);
        	}
        	
        	var rs =  RooTicket.singleton();		
        	var uri = new WebKit.URIRequest("https://roojs.com/admin.php/MTrack/View/" + tid);
        	var hd = uri.get_http_headers();
        	var authCode = Base64.encode ("%s:%s".printf(rs.username, rs.password).data);
        	hd.append("Authorization", "Basic %s".printf(authCode));
        	
        	 this.el.load_request(uri);
        }
    }




    public class Xcls_spinner : Object
    {
        public Gtk.Spinner el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_spinner(MergeBranch _owner )
        {
            _this = _owner;
            _this.spinner = this;
            this.el = new Gtk.Spinner();

            // my vars (dec)

            // set gobject values
            this.el.hexpand = true;
            this.el.vexpand = true;
        }

        // user defined functions
    }


    public class Xcls_Button32 : Object
    {
        public Gtk.Button el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_Button32(MergeBranch _owner )
        {
            _this = _owner;
            this.el = new Gtk.Button();

            // my vars (dec)

            // set gobject values
            this.el.relief = Gtk.ReliefStyle.NONE;
            this.el.label = "Cancel";
        }

        // user defined functions
    }

    public class Xcls_mergebtn : Object
    {
        public Gtk.Button el;
        private MergeBranch  _this;


            // my vars (def)

        // ctor
        public Xcls_mergebtn(MergeBranch _owner )
        {
            _this = _owner;
            _this.mergebtn = this;
            this.el = new Gtk.Button();

            // my vars (dec)

            // set gobject values
            this.el.label = "Do Merge";

            // init method

            {
               this.el.get_style_context().add_class("suggested-action");
            }
        }

        // user defined functions
        public void updateState () {
        	if (_this.actionsel.selectedAction() == "") {
        		// need to select an action..
        		this.el.set_sensitive(false);
        		return;
        	
        	
        	}
        		this.el.set_sensitive(true);
        		return;
        }
    }

}
